Least Frequently Used Cache - Amazon Top Interview Questions


Problem Statement :


Implement a least frequently used cache with the following methods:

LFUCache(int capacity) constructs a new instance of a LFU cache with the given capacity.
get(int key) retrieves the value associated with the key key.
 If it does not exist, return -1.
As a side effect, this key's usage is incremented (used for eviction).
set(int key, int val) updates the key key with value val. 
If updating this key-value pair exceeds capacity, then evicts the least frequently used key-value pair. 
If there is more than one key that's been used least frequently used, it should use the least recently used key.
Each method should be done in \mathcal{O}(1)O(1) time.

Constraints

n ≤ 100,000 where n is the number of calls to get and set.

Example 1

Input

methods = ["constructor", "set", "get", "set", "set", "set", "get", "get"]

arguments = [[3], [1, 10], [1], [2, 20], [3, 30], [4, 40], [3], [2]]`

Output

[None, None, 10, None, None, None, 30, -1]

Explanation

We create an LFUCache of capacity 3.

Set key of 1 to value 10. Size of cache is now 1

We get 1 which has value of 10

Set key of 2 to value 20. Size of cache is now 2

Set key of 3 to value 30. Size of cache is now 3

Set key of 4 to value 40. Size exceeds capacity, so now we evict the least frequently used key. Since 
both 2 and 3 are tied for being used the least, we evict the least recently used key which is 2.

We get 3 which has value of 30

We get 2 which has been evicted so we return -1



Solution :



title-img




                        Solution in C++ :

void set(int key, int value) {
    // Scenario 1:
    if (!keyMap.count(key)) {

        // Case 1:
        if (keyMap.size() < cap) {
            freqMap[1].emplace_back(key, value);
            keyMap[key] = {1, --freqMap[1].end()};
            lowestFreq = 1;
        } 

        // Case 2:
        if (keyMap.size() == cap) {
            if (lowestFreq == 0) return;
            auto [k, v] = freqMap[lowestFreq].front();
            freqMap[lowestFreq].erase(freqMap[lowestFreq].begin());
            keyMap.erase(k);
            set(key, value);
        }
    } 

   // Scenario 2:
   if(keyMap.count(key) {
        auto [freq, it] = keyMap[key];
        if (freqMap[freq].size() == 1 and freq == lowestFreq) lowestFreq++;
        freqMap[freq].erase(it);
        freqMap[freq+1].emplace_back(key, value);
        keyMap[key] = {freq+1, --freqMap[freq+1].end()};
    }
}
                    


                        Solution in Java :

import java.util.*;

class LFUCache {
    private Map<Integer, Integer> values;
    private Map<Integer, Integer> freq;
    private Map<Integer, LinkedHashSet<Integer>> lists;
    private int capacity;
    private int minIndex = -1; // to keep track of lists (index)

    public LFUCache(int capacity) {
        this.capacity = capacity;
        values = new HashMap<>();
        freq = new HashMap<>();
        lists = new HashMap<>();
        lists.put(1, new LinkedHashSet<>()); // create 1 count bucket
    }

    public int get(int key) {
        // key not found
        if (!values.containsKey(key))
            return -1;
        // update frequency counts
        int count = freq.get(key);
        freq.put(key, count + 1);
        // remove from <count> bucket lists
        lists.get(count).remove(key);
        // update min to pick next bucket from list
        if (count == minIndex && lists.get(count).size() == 0)
            minIndex++;

        // add it new count bucket lists
        lists.computeIfAbsent(count + 1, f -> new LinkedHashSet());
        lists.get(count + 1).add(key);
        return values.get(key);
    }

    public void set(int key, int val) {
        // not enough capacity
        if (capacity <= 0)
            return;

        // Case 1: if key exists
        if (values.containsKey(key)) {
            values.put(key, val);
            get(key); // update count
            return;
        }

        // case 2: if capacity is Full
        // evict policy
        if (values.size() >= capacity) {
            int evit = lists.get(minIndex).iterator().next();
            lists.get(minIndex).remove(evit);
            values.remove(evit);
        }

        values.put(key, val);
        freq.put(key, 1);
        minIndex = 1; // reset min index
        lists.get(minIndex).add(key);
    }
}
                    


                        Solution in Python : 
                            
from collections import defaultdict, OrderedDict


class Node:
    def __init__(self, key: int, value: int, count: int = 1):
        self.key = key
        self.value = value
        self.count = count


class LFUCache:
    def __init__(self, capacity: int):
        self._size = 0
        self._capacity = capacity
        self._nodes = {}
        self._counts = defaultdict(OrderedDict)
        self._min_count = 0

    def _touch(self, node: Node):
        self._counts[node.count].popitem(node.key)
        if not self._counts[self._min_count]:
            self._min_count += 1

        node.count += 1
        self._counts[node.count][node.key] = node

    def get(self, key: int) -> int:
        if key not in self._nodes:
            return -1

        node = self._nodes[key]
        self._touch(node)
        return node.value

    def set(self, key: int, value: int):
        if not self._capacity:
            return

        if key in self._nodes:
            node = self._nodes[key]
            self._touch(node)
            node.value = value
        else:
            if self._size == self._capacity:
                evict_key, _ = self._counts[self._min_count].popitem(last=False)
                self._nodes.pop(evict_key)
                self._size -= 1

            node = Node(key, value)
            self._nodes[key] = node
            self._counts[1][key] = node
            self._min_count = 1
            self._size += 1
                    


View More Similar Problems

Costly Intervals

Given an array, your goal is to find, for each element, the largest subarray containing it whose cost is at least k. Specifically, let A = [A1, A2, . . . , An ] be an array of length n, and let be the subarray from index l to index r. Also, Let MAX( l, r ) be the largest number in Al. . . r. Let MIN( l, r ) be the smallest number in Al . . .r . Let OR( l , r ) be the bitwise OR of the

View Solution →

The Strange Function

One of the most important skills a programmer needs to learn early on is the ability to pose a problem in an abstract way. This skill is important not just for researchers but also in applied fields like software engineering and web development. You are able to solve most of a problem, except for one last subproblem, which you have posed in an abstract way as follows: Given an array consisting

View Solution →

Self-Driving Bus

Treeland is a country with n cities and n - 1 roads. There is exactly one path between any two cities. The ruler of Treeland wants to implement a self-driving bus system and asks tree-loving Alex to plan the bus routes. Alex decides that each route must contain a subset of connected cities; a subset of cities is connected if the following two conditions are true: There is a path between ever

View Solution →

Unique Colors

You are given an unrooted tree of n nodes numbered from 1 to n . Each node i has a color, ci. Let d( i , j ) be the number of different colors in the path between node i and node j. For each node i, calculate the value of sum, defined as follows: Your task is to print the value of sumi for each node 1 <= i <= n. Input Format The first line contains a single integer, n, denoti

View Solution →

Fibonacci Numbers Tree

Shashank loves trees and math. He has a rooted tree, T , consisting of N nodes uniquely labeled with integers in the inclusive range [1 , N ]. The node labeled as 1 is the root node of tree , and each node in is associated with some positive integer value (all values are initially ). Let's define Fk as the Kth Fibonacci number. Shashank wants to perform 22 types of operations over his tree, T

View Solution →

Pair Sums

Given an array, we define its value to be the value obtained by following these instructions: Write down all pairs of numbers from this array. Compute the product of each pair. Find the sum of all the products. For example, for a given array, for a given array [7,2 ,-1 ,2 ] Note that ( 7 , 2 ) is listed twice, one for each occurrence of 2. Given an array of integers, find the largest v

View Solution →